/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form;

import Helpers.FileHelper;
import Helpers.MessageHelper;
import common.constants;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import models.classObj;
import models.enumObj;
import models.pointObj;
import models.studentObj;
import models.timetableObj;

/**
 *
 * @author HoiNT2
 */
public class frmThemSinhVienVaoMon extends javax.swing.JDialog {

    private static String fileClassPath = "data/Class.csv";
    private static String filePath = "data/";

    /**
     * Creates new form frmThemSinhVienVaoMon
     */
    public frmThemSinhVienVaoMon(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        initCombobox();
    }

    private void initCombobox() {
        try {
            ArrayList<classObj> lstClass = FileHelper.readFileNew(classObj.class, fileClassPath, enumObj.classObj);
            if (lstClass != null && lstClass.size() > 0) {
                lstClass.stream().forEach((itemGroup) -> {
                    jcbClass.addItem(itemGroup);
                    jcbClassCourse.addItem(itemGroup);
                });
            }
            //TODO: Table sv
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jcbClass = new javax.swing.JComboBox();
        jLabel6 = new javax.swing.JLabel();
        jcbSinhVien = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jcbClassCourse = new javax.swing.JComboBox();
        jLabel8 = new javax.swing.JLabel();
        jcbCourse = new javax.swing.JComboBox();
        btnThem = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Thêm sinh viên vào môn học");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Chọn sinh viên"));

        jLabel5.setText("Lớp:");

        jcbClass.setName("cbxLop"); // NOI18N
        jcbClass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcbClassActionPerformed(evt);
            }
        });

        jLabel6.setText("Sinh viên:");

        jcbSinhVien.setName("cbxLop"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel6)
                    .addComponent(jLabel5))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jcbClass, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jcbSinhVien, 0, 194, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jcbClass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jcbSinhVien, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Chọn môn"));

        jLabel7.setText("Lớp:");

        jcbClassCourse.setName("cbxLop"); // NOI18N
        jcbClassCourse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcbClassCourseActionPerformed(evt);
            }
        });

        jLabel8.setText("Môn:");

        jcbCourse.setName("cbxLop"); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8)
                    .addComponent(jLabel7))
                .addGap(18, 43, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jcbClassCourse, 0, 192, Short.MAX_VALUE)
                    .addComponent(jcbCourse, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jcbClassCourse, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jcbCourse, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        btnThem.setText("Thêm");
        btnThem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnThemActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(104, 104, 104)
                        .addComponent(btnThem, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(42, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnThem)
                .addContainerGap(15, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void jcbClassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcbClassActionPerformed
        // TODO add your handling code here:
        String text = jcbClass.getSelectedItem().toString();
        if (!text.equalsIgnoreCase("Chọn Lớp")) {
            String filePath = "data/" + text + ".csv";
            try {
                ArrayList<studentObj> lstSv = FileHelper.readFileNew(studentObj.class, filePath, enumObj.studentOb);

                jcbSinhVien.setModel(new DefaultComboBoxModel());
                if (lstSv != null && lstSv.size() > 0) {
                    lstSv.stream().forEach((itemGroup) -> {
                        jcbSinhVien.addItem(itemGroup.getMSSV() + "-" + itemGroup.getHoTen());
                    });
                }

                //TODO: Table sv
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }

    }//GEN-LAST:event_jcbClassActionPerformed

    private void jcbClassCourseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcbClassCourseActionPerformed
        // TODO add your handling code here:
        String text = jcbClassCourse.getSelectedItem().toString();
        if (!text.equalsIgnoreCase("Chọn Lớp")) {
            String fileTKBPath = "data/TKB" + text + ".csv";
            try {
                ArrayList<timetableObj> lstTKB = FileHelper.readFileNew(timetableObj.class, fileTKBPath, enumObj.timetableObj);

                jcbCourse.setModel(new DefaultComboBoxModel());
                if (lstTKB != null && lstTKB.size() > 0) {
                    lstTKB.stream().forEach((itemGroup) -> {
                        jcbCourse.addItem(itemGroup.getCode() + "-" + itemGroup.getName());
                    });
                }
                //TODO: Table sv
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }//GEN-LAST:event_jcbClassCourseActionPerformed

    private void btnThemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnThemActionPerformed
        // TODO add your handling code here:
        if (jcbSinhVien.getSelectedItem() == null) {
            MessageHelper.Message("Vui lòng chọn sinh viên!", "Thông báo", JOptionPane.ERROR_MESSAGE);
            return;
        }

        if (jcbCourse.getSelectedItem() == null) {
            MessageHelper.Message("Vui lòng chọn môn!", "Thông báo", JOptionPane.ERROR_MESSAGE);
            return;
        }

        String maLopTheoSV = jcbClass.getSelectedItem().toString().trim();
        String maLop = jcbClassCourse.getSelectedItem().toString().trim();
        String mssv = jcbSinhVien.getSelectedItem().toString().split("-")[0].trim();
        String maMonHoc = jcbCourse.getSelectedItem().toString().split("-")[0].trim();

        String filePathMon = filePath + maLop + "-" + maMonHoc + ".csv";

        try {
            ArrayList<pointObj> lstPointCurrent = FileHelper.readFileNew(pointObj.class, filePathMon, enumObj.pointObj);
            if (lstPointCurrent.stream().filter(m -> m.getCode().equals(mssv)).count() > 0) {
                MessageHelper.Message("Sinh viên đã tồn tại trong lớp học!", "Thông báo", JOptionPane.ERROR_MESSAGE);
                return;
            }

            String filePathSV = "data/" + maLopTheoSV + ".csv";
            ArrayList<studentObj> lstSv = FileHelper.readFileNew(studentObj.class, filePathSV, enumObj.studentOb);
            for (studentObj sv : lstSv) {
                if (sv.getMSSV().equals(mssv)) {
                    int stt = 0;
                    if (lstPointCurrent != null && lstPointCurrent.size() > 0) {
                        stt = lstPointCurrent.get(lstPointCurrent.size() - 1).getId() + 1;
                    }
                    pointObj stu = new pointObj(stt, sv.getMSSV(), sv.getHoTen(), 0, 0, 0, 0);
                    lstPointCurrent.add(stu);
                    break;
                }
            }

            boolean result = FileHelper.writeFile(lstPointCurrent, filePathMon, constants.TITLE_POINT);
            if (result) {
                frmQLPoint frmPoint = (frmQLPoint) this.getParent();
                frmPoint.setTable(lstPointCurrent);
                MessageHelper.Message("Thêm sinh viên vào môn thành công!");

            } else {
                MessageHelper.Message("Thêm sinh viên vào môn thất bại!");
            }
        } catch (IOException ex) {

        }

    }//GEN-LAST:event_btnThemActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(frmThemSinhVienVaoMon.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(frmThemSinhVienVaoMon.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(frmThemSinhVienVaoMon.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(frmThemSinhVienVaoMon.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                frmThemSinhVienVaoMon dialog = new frmThemSinhVienVaoMon(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnThem;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JComboBox jcbClass;
    private javax.swing.JComboBox jcbClassCourse;
    private javax.swing.JComboBox jcbCourse;
    private javax.swing.JComboBox jcbSinhVien;
    // End of variables declaration//GEN-END:variables
}
